=== debian/control ===
--- 
+++ 
@@ -5,8 +5,8 @@
 Bugs: mailto:marillat@deb-multimedia.org
 Homepage: https://github.com/fraunhoferhhi/vvenc/releases
 Rules-Requires-Root: no
-Standards-Version: 4.6.2
-Build-Depends: debhelper-compat (= 13), cmake (>= 3.13.0~), ninja-build, quilt
+Standards-Version: 4.7.0
+Build-Depends: debhelper-compat (= 13), cmake (>= 3.13.0~), ninja-build
 
 Package: vvdec
 Architecture: any
@@ -29,7 +29,7 @@
  available in the Main10 profile, with support for some high-level features
  still pending.
 
-Package: libvvdec2
+Package: libvvdec3
 Architecture: any
 Section: libs
 Multi-Arch: same
@@ -58,7 +58,7 @@
 Architecture: any
 Section: libdevel
 Multi-Arch: same
-Depends: libvvdec2 (= ${binary:Version}), ${misc:Depends}
+Depends: libvvdec3 (= ${binary:Version}), ${misc:Depends}
 Description: Fraunhofer Versatile Video Decoder - devel files.
  Versatile Video Coding (VVC) is the most recent international video coding
  standard, developed by the Joint Video Experts Team (JVET) of the ITU-T
