=== debian/watch ===
version=4

opts=repack \
https://github.com/fraunhoferhhi/vvdec/tags \
(?:.*?/)?v?(\d[\d.]*)@ARCHIVE_EXT@
